//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function box_file
{
	my.polygon = on;
	if(level_color == color_green){ent_morphskin(me,"box_green.bmp");}
	if(level_color == color_red){ent_morphskin(me,"box_red.bmp");}
	if(level_color == color_blue){ent_morphskin(me,"box_blue.bmp");}
	my.ent_type = type_box;
}
action box_orange{box_file();}
action box_green{box_file();}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//8 switches in every level
var switches[8];
define cswitch,skill1;
define cmice,skill2;
define chacker,skill3;
action switcher
{
	return;
}
action floor
{
	my.transparent = off;
	my.polygon = on;
	if(level_color == color_green){ent_morphskin(me,"floor_green.bmp");}
	if(level_color == color_red){ent_morphskin(me,"floor_red.bmp");}
	if(level_color == color_blue){ent_morphskin(me,"floor_blue.bmp");}
	my.ent_type = type_scenery;
}
action wall_4
{
	my.polygon = on;
	if(level_color == color_green){ent_morphskin(me,"wall4green.bmp");}
	if(level_color == color_red){ent_morphskin(me,"wall4red.bmp");}
	if(level_color == color_blue){ent_morphskin(me,"wall4blue.bmp");}
	my.ent_type = type_scenery;
}
action wall_1{wall_4();}
function tree_run
{
	my.pan = random(360);
	my.polygon = on;
	my.transparent = on;
	my.bright = on;
	while(1)
	{
		my.alpha = random(60)+30;
		wait(-random(0.5)-0.1);
	}
	my.ent_type = type_scenery;
}
action blocktree1{tree_run();}
action blocktree2{tree_run();}
action hextree{tree_run();}
action cactus1{tree_run();}
action flare_act
{
	my.transparent = on;
	my.bright = on;
	my.passable = on;
	my.alpha = 99;
	my.facing = off;
	my.oriented = on;
}
action flare_blue
{
	my.transparent = on;
	my.bright = on;
	my.passable = on;
	my.alpha = 30;
	my.facing = off;
	my.oriented = on;
}
action lamp
{
	you = ent_create("flare.bmp",my.x,flare_act);
	my.polygon = on;
	while(!you){wait(1);}
	while(you)
	{
		vec_lerp(your.x,my.x,camera.x,0.7);
		vec_set(temp.x,camera.x);
		vec_sub(temp,your.x);
		vec_to_angle(your.pan,temp.x);
		wait(1);
	}
}
action plate_light
{
	you = ent_create("flare_blue.bmp",my.x,flare_blue);
	my.polygon = on;
	while(!you){wait(1);}
	while(you)
	{
		vec_lerp(your.x,my.x,camera.x,0.6);
		vec_set(temp.x,camera.x);
		vec_sub(temp,your.x);
		vec_to_angle(your.pan,temp.x);
		wait(1);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
action box_movable
{
//	my.passable = on;
	my.ent_type = type_movable;
	vec_set(my.targetpos_x,my.x);
	while(1)
	{
		move_bodyblock();
		wait(1);
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// skill1 switch 0
// skill2 cmice 0
// skill3 chacker 0
action firewall
{
	my.cmice = 10000;
	my.chacker = 10000;
	if(level_current == 1)
	{
		my.cmice = 5;
		my.chacker = 0;
	}
	if(level_current == 4)
	{
		my.cmice = 10;
		my.chacker = 1;
	}
	my.invisible = on;
	while(switches[my.skill1] == 0)
	{
		if(mice_eaten >= my.cmice && hackers_eaten >= my.chacker)
		{
			break;
		}
		effect(part_firewall_red,1,my.x,nullvector);
		effect(part_firewall_yellow,1,my.x,nullvector);
		wait(4);
	}
	ent_remove(me);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//needed for fsaa
sky default_sky
{
	type = "sky+6.tga";
	flags = visible,cube;
}