//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function part_firewall_event
{
	my.alpha -= 2*time;
	my.lifespan = 5;
	my.size = my.alpha*0.8+5;
	if(my.alpha < 1){my.lifespan = 0;}
}
function part_firewall
{
	my.alpha = 60;
	my.x+=random(80)-40;
	my.y+=random(80)-40;
	my.function = part_firewall_event;
	my.move = 1;
	my.transparent = on;
	my.vel_x = random(4)-2;
	my.vel_y = random(4)-2;
	my.vel_z = 4+random(8);
	my.bright = on;
}
function part_firewall_red
{
	my.red = random(100)+150;
	my.green = random(50);
	my.blue = random(20);
	part_firewall();
}
function part_firewall_yellow
{
	my.red = random(100)+150;
	my.green = my.red-random(50);
	my.blue = random(20);
	part_firewall();
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function part_death_event
{
	my.alpha -= 2*time;
	my.lifespan = 5;
	if(my.alpha < 1){my.lifespan = 0;}
}
function part_snake_death
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.red = random(30);
	my.green = 200+random(50);
	my.blue = 0;
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.gravity = 0.3;
}
function part_box_destroy
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.x+=random(128)-64;
	my.y+=random(128)-64;
	my.z+=random(128)-64;
	my.gravity = 0.3;
	if(level_color == color_orange)
	{
		my.red = 200+random(50);
		my.green = 100+random(50);
		my.blue = 0;
	}
	if(level_color == color_red)
	{
		my.red = 200+random(50);
		my.green = 0;
		my.blue = 0;
	}
	if(level_color == color_green)
	{
		my.red = 0;
		my.green = 200+random(50);
		my.blue = 0;
	}
	if(level_color == color_blue)
	{
		my.red = 100;
		my.green = 150;
		my.blue = 255;
	}
}
function part_mouse_destroy
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.red = 200+random(50);
	my.green = my.red;
	my.blue = my.red;
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.gravity = 0.3;
}

function part_hacker_destroy1
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.red = 200+random(50);
	my.green = 0;
	my.blue = 200+random(50);
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.gravity = 0.3;
}
function part_hacker_destroy2
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.red = 200+random(50);
	my.green = 150+random(50);
	my.blue = 0;
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.gravity = 0.3;
}
function part_bomb1
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.red = 200+random(50);
	my.green = 150+random(50);
	my.blue = 0;
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.gravity = 0.3;
}
function part_bomb2
{
	my.alpha = 100;
	my.function = part_death_event;
	my.move = 1;
	my.transparent = on;
	my.red = 200+random(50);
	my.green = random(50);
	my.blue = 0;
	my.bright = on;
	my.size = 5+random(20);
	my.vel_x = random(6)-3;
	my.vel_y = random(6)-3;
	my.vel_z = random(6);
	my.gravity = 0.3;
}