//////////////////////////////////////////////////////////////////////////////////////////
define speed,skill1;
define gravity,skill2;
define health,skill4;
define targetpos_x,skill5;
define targetpos_y,skill6;
define targetpos_z,skill7;
define move_x,skill8;
define move_y,skill9;
define move_z,skill10;
define direction,skill11;

//for the snake
define oldtarget_x,skill12;
define oldtarget_y,skill13;
define oldtarget_z,skill14;
//for enemies
define final_target_x,skill12;
define final_target_y,skill13;
define final_target_z,skill14;
//for the tail
define tail_slot,skill15;
//for the enemies
define see_target,skill15;
define target_entity,skill16;
define aggression,skill17;

define up,0;
define right,1;
define down,2;
define left,3;

var reldist[3];
var absdist[3];

var handle_tail[100];

var tail_targetx[100];
var tail_targety[100];
var tail_targetz[100];

//triggers a pulse when the snake is at it's target,
//and continues moving
//at this point new blocks can be added
var change_move;
var oldtarget[3];
//////////////////////////////////////////////////////////////////////////////////////////
//make all pointers empty
//to be called when a world is loaded
function tail_empty
{
	var i = 0;
	while(i < 100)
	{
		handle_tail[i] = 0;
		i+=1;
	}
}
//find an empty slot
//and write the me entity in it
function tail_write
{
	var i = 0;
	while(handle_tail[i] != 0)
	{
		i+=1;
	}
	handle_tail[i] = handle(me);
	my.tail_slot = i;
}
function tail_lastinrow
{
	var i = 0;
	while(handle_tail[i] != 0)
	{
		i+=1;
	}
	i-=1;
	return(i);
}
//works!
function tail_control
{
	tail_targetx[0] = player.targetpos_x;
	tail_targety[0] = player.targetpos_y;
	tail_targetz[0] = player.targetpos_z;
	var i = 99;
	while(i > 0)
	{
		tail_targetx[i] = tail_targetx[i-1];
		tail_targety[i] = tail_targety[i-1];
		tail_targetz[i] = tail_targetz[i-1];
		temp.x = tail_Targetx[i];
		temp.y = tail_Targety[i];
		temp.z = tail_Targetz[i];
		i-=1;
	}
}
function tail_readtarget
{
	if(change_move == 0){return;}
	//get a pointer to the previous block in the row
	you = ptr_for_handle(handle_tail[my.tail_slot-1]);
	if(!you){return;}//to avoid empty pointers => make a remove function?
	if(!player){return;}
	//set new target
	my.targetpos_x = tail_targetx[my.tail_slot];
	my.targetpos_y = tail_targety[my.tail_slot];
	my.targetpos_z = tail_targetz[my.tail_slot];
	my.health = player.health;
	my.speed = player.speed;
}
//////////////////////////////////////////////////////////////////////////////////////////
function target_grid
{
	my.targetpos_x = 64*int((my.targetpos_x)/64+0.5*sign(my.targetpos_x));
	my.targetpos_y = 64*int((my.targetpos_y)/64+0.5*sign(my.targetpos_y));
	my.targetpos_z = my.z;
}
function position_grid
{
	my.x = 64*int((my.x)/64+0.5*sign(my.x));
	my.y = 64*int((my.y)/64+0.5*sign(my.y));
}
function target_place
{
	change_move = 0;
	if(vec_dist(my.targetpos_x,my.x) > my.speed*time_step*0.5)
	{
		return;
	}
	tail_control();
	change_move = 1;
	my.oldtarget_x = my.targetpos_x;
	my.oldtarget_y = my.targetpos_y;
	my.oldtarget_z = my.targetpos_z;
	
	my.x = my.targetpos_x;
	my.y = my.targetpos_y;
	if(my.direction == up)
	{
		my.targetpos_x = my.x;
		my.targetpos_y+=64;
	}
	if(my.direction == right)
	{
		my.targetpos_x+= 64;
		my.targetpos_y = my.y;
	}
	if(my.direction == down)
	{
		my.targetpos_x = my.x;
		my.targetpos_y-=64;
	}
	if(my.direction == left)
	{
		my.targetpos_x -= 64;
		my.targetpos_y = my.y;
	}
	target_grid();
}
function snake_movement_classic
{
	my.move_x = sign(my.targetpos_x-my.x)*my.speed*time_step;
	my.move_y = sign(my.targetpos_y-my.y)*my.speed*time_step;
	my.move_z = sign(my.targetpos_z-my.z)*my.speed*time_step;
	c_move(me, nullvector, my.move_x, glide + ignore_passents);
	//following lines of code make the snake only able to move in only one direction
	//moving left or right
	if(abs(my.targetpos_x-my.x) > abs(my.targetpos_y-my.y))
	{
		my.y = my.targetpos_y;
	}
	//moving up or down
	if(abs(my.targetpos_x-my.x) < abs(my.targetpos_y-my.y))
	{
		my.x = my.targetpos_x;
	}
}
function snake_input_classic
{
	if(key_cur == 1){my.direction = right;}
	if(key_cul == 1){my.direction = left;}
	if(key_cuu == 1){my.direction = up;}
	if(key_cud == 1){my.direction = down;}
}
function test_collission
{
	c_trace(my.x,my.targetpos_x,ignore_me + use_box);
	if(trace_hit == 1)
	{
		if(you)
		{
			if(your.ent_type == type_mouse 
			|| your.ent_type == type_hacker
			|| your.ent_type == type_bomb)
			{
				your.health = 0;
				return;
			}
			//			if(your.ent_type == type_movable)
			//			{
				//				your.speed = my.speed;
				//				vec_set(your.targetpos_x,my.targetpos_x);
				//				if(my.direction == up){your.targetpos_y+=64;}
				//				if(my.direction == down){your.targetpos_y-=64;}
				//				if(my.direction == right){your.targetpos_x+=64;}
				//				if(my.direction == left){your.targetpos_x-=64;}
				//				return;
			//			}
		}
		my.health = 0;
	}
	
}
function snake_speed
{
	my.speed = 15;
	if(level_current == 1){my.speed = 30;}
	if(level_current == 2){my.speed = 17;}
	if(level_current == 3){my.speed = 18;}
	if(level_current == 4){my.speed = 19;}
	if(level_current == 5){my.speed = 20;}
	if(level_current == 6){my.speed = 21;}
	if(level_current == 7){my.speed = 22;}
	if(level_current == 8){my.speed = 25;}
}
///////////////////////////////////////////////////////////////////////////////////////////
//the action for the first block
action snake_classic
{
	wait(1);
	c_setminmax(me);
	my.health = 1;
	player = me;
	vec_set(my.targetpos_x,my.x);
	my.targetpos_x+=64;
	my.direction = right;
	my.speed = 15;
	tail_write();
	position_grid();
	while(my.health > 0)
	{
		while(game_active == 0){wait(1);}
		target_place();
		snake_movement_classic();
		snake_input_classic();
		test_collission();
		camera_classic();
		wait(1);
	}
	snd_play(snake_death_snd,40,0);
	while(my.health > -64)
	{
		effect(part_snake_death,1,my.x,nullvector);
		my.z-=time_step;
		my.health-=time_Step;
		wait(1);
	}
	times_died+=1;
	ent_remove(me);
}
//////////////////////////////////////////////////////////////////////////////////////////////////
var checkangle[3];

function move_bodyblock
{
	my.move_x = sign(my.targetpos_x-my.x)*my.speed*time_step;
	my.move_y = sign(my.targetpos_y-my.y)*my.speed*time_step;
	my.move_z = sign(my.targetpos_z-my.z)*my.speed*time_step;
	vec_add(my.x,my.move_x);
	//moving left or right
	if(abs(my.targetpos_x-my.x) > abs(my.targetpos_y-my.y))
	{
		my.y = my.targetpos_y;
	}
	//moving up or down
	if(abs(my.targetpos_x-my.x) < abs(my.targetpos_y-my.y))
	{
		my.x = my.targetpos_x;
	}
}
action bodyblock
{
	wait(1);
	c_setminmax(me);
	tail_write();
	my.health = 1;
	my.passable = (my.tail_slot == 1);
	vec_set(my.targetpos_x,my.x);
	if(opt_shader >= 1){my.material = mtl_specular;}
	position_grid();
	while(my.health > 0)
	{
		while(game_active == 0){wait(1);}
		if(!player){break;}
		if(player.health < 1){break;}
		proc_late();
		tail_readtarget();
		move_bodyblock();
		wait(1);
	}
	while(my.health > -100)
	{
		effect(part_snake_death,1,my.x,nullvector);
		my.z-=time_step;
		my.health-=time_Step;
		wait(1);
	}
	ent_remove(me);
}
function add_block
{
	var i;
	i = tail_lastinrow()+1;
	temp.x = tail_targetx[i];
	temp.y = tail_targety[i];
	temp.z = tail_targetz[i];
	ent_create("snake_box.mdl",temp,bodyblock);
}