/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//texts
sound text1_snd = "text1.wav";
sound text2_snd = "text2.wav";
sound text3_snd = "text3.wav";
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//bmaps
BMAP BG1_bmap = "BG1.BMP";
BMAP NOTIFICATION_bmap = "NOTIFICATION.BMP";
BMAP EMAIL_bmap = "EMAIL.BMP";
BMAP MOUSE_STORY_bmap = "MOUSE_STORY.TGA";
BMAP DOWNLOADLINK_bmap = "DOWNLOADLINK.TGA";
BMAP DOWNLOADING_bmap = "DOWNLOADING.BMP";
BMAP RESNAKE_SPLASH_bmap = "RESNAKE_SPLASH.BMP";

var story_running;
var sound_handle;

function story_end();
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
panel bg_1
{
	bmap = BG1_bmap;
	layer = 5;
}
panel notification_mail
{
	button = 0,0,NOTIFICATION_bmap,NOTIFICATION_bmap,NOTIFICATION_bmap,story_mail,null,menu_over;
	layer = 6;
}
panel bg_email
{
	bmap = EMAIL_bmap;
	pos_X = 100;
	pos_y = 100;
	button = 210,303,DOWNLOADLINK_bmap,DOWNLOADLINK_bmap,DOWNLOADLINK_bmap,story_download,null,menu_over;
	layer = 6;
}

panel notification_download
{
	bmap = DOWNLOADING_bmap;
	pos_X = 350;
	pos_y = 250;
	layer = 7;
}
panel resnake_splash
{
	bmap = RESNAKE_SPLASH_bmap;
	pos_X = 200;
	pos_y = 150;
	layer = 8;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//scene 1 the chat
function story_start
{
	story_running = 1;
	hide_menus();
	on_esc = story_end;
	sound_handle = snd_play(text1_snd,100,0);
	if(story_running == 0){return;}
	bg_1.visible = on;
	wait(-14);
	if(story_running == 0){return;}
	sound_handle = snd_play(text2_snd,100,0);
	notification_mail.pos_x = 800;
	notification_mail.pos_y = 100;
	notification_mail.visible = on;
	while(notification_mail.pos_x > 650)
	{
		if(menus.visible == on){return;}
		notification_mail.pos_x-=8*time;
		wait(1);
	}
	mouse_mode = 2;
	mouse_map = MOUSE_STORY_bmap;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//scene 2 the mail
function story_mail
{
	menu_over();
	notification_mail.visible = off;
	bg_email.visible = on;
	wait(-1);
	if(story_running == 0){return;}
	sound_handle = snd_play(text3_snd,100,0);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//scene 3 the download
function story_splash();
function story_download
{
	if(story_running == 0){return;}
	menu_over();
	notification_download.visible = on;
	wait(-3);
	if(story_running == 0){return;}
	story_splash();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//scene 4 the splash
function story_splash
{
	resnake_splash.visible = on;
	wait(-3);
	if(story_running == 0){return;}
	story_end();
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//entering the menu
function story_end
{
	story_running = 0;
	snd_stop(sound_handle);
	//displaying the menu
	bg_1.visible = off;
	bg_email.visible = off;
	notification_mail.visible = off;
	notification_download.visible = off;
	play_menu_music();
	display_main();
	wait(-1);
	resnake_splash.visible = off;
	mouse_map = SNAKE_MENU_bmap;
}