/////////////////////////////////////////////////////////////////////////////////////////////
// resnake.wdl
/////////////////////////////////////////////////////////////////////////////////////////////
//paths
path "files";
/////////////////////////////////////////////////////////////////////////////////////////////
//files
BMAP MENU_BUTTONN_bmap = "MENU_BUTTONN.BMP";
BMAP MENU_BUTTONO_bmap = "MENU_BUTTONO.BMP";
BMAP MENU_BUTTONC_bmap = "MENU_BUTTONC.BMP";

BMAP MENU_BUTTONN2_bmap = "MENU_BUTTONN2.BMP";
BMAP MENU_BUTTONO2_bmap = "MENU_BUTTONO2.BMP";
BMAP MENU_BUTTONC2_bmap = "MENU_BUTTONC2.BMP";

BMAP BUTTON_LC_bmap = "BUTTON_LC.TGA";
BMAP BUTTON_LN_bmap = "BUTTON_LN.TGA";
BMAP BUTTON_LO_bmap = "BUTTON_LO.TGA";
BMAP BUTTON_RC_bmap = "BUTTON_RC.TGA";
BMAP BUTTON_RN_bmap = "BUTTON_RN.TGA";
BMAP BUTTON_RO_bmap = "BUTTON_RO.TGA";
BMAP GREYOUT_bmap = "GREYOUT.BMP";

BMAP SNAKE_MENU_bmap = "SNAKE_MENU.BMP";
BMAP GAME_START_bmap = "GAME_START.BMP";
BMAP HUD_BG_bmap = "HUD_BG.BMP";
FONT font_menu = <Resnake_font.bmp>, 13, 17;
FONT font_end = <endtext.tga>, 13, 19;
/////////////////////////////////////////////////////////////////////////////////////////////
sound menu_over_snd = "menu_over.wav";
sound menu_click_snd = "menu_click.wav";
sound menu_enter_snd = "menu_enter.wav";

sound hacker_destroy_snd = "hacker_destroy.wav";
sound mouse_birth_snd = "mouse_born.wav";
sound snake_death_snd = "snake_die.wav";

string title_mus = "titlesong.ogg";
string game1_mus = "dabeat.ogg";
string game2_mus = "the_saturn_tragedy.ogg";
string game3_mus = "friday_plans.ogg";
string game4_mus = "end_of _summer.ogg";
string game5_mus = "the_guide_to_saturn.ogg";

string menu_mus = "Digital_paradise.ogg";
/////////////////////////////////////////////////////////////////////////////////////////////
var video_mode = 7;
var video_screen = 1;
var fps_max = 90;
var fps_min = 16;
var max_entities = 1000;
var shadow_stencil = on;
define ent_type,skill99;
define type_scenery,0;
define type_snake,1;
define type_mouse,2;
define type_box,3;
define type_hacker,4;
define type_movable,5;
define type_bomb,6;
var_nsave game_active;

var_nsave level_color;
define color_orange,0;
define color_green,1;
define color_blue,2;
define color_red,3;

var_info opt_fsaa;
var_info opt_shader;
var_info opt_shadow;
var_info opt_sound;
var_info opt_music;

var_nsave music_handle;
var_nsave mice_level;
var_nsave hackers_level;
var_nsave mice_eaten;
var_nsave hackers_eaten;
var_nsave boxes_level;
var_nsave boxes_destroyed;
var_nsave level_current;

var_nsave mice_panel;
var_nsave hackers_panel;
var_nsave boxes_panel;

var_nsave money_earned;
var viewed_movie;
var level_opened = 1;
var times_died;
var files_lost;
var time_played;
/////////////////////////////////////////////////////////////////////////////////////////////
//full screen anti aliasing dll
dllfunction fsaa_maxQualityNonMaskable();
dllfunction fsaa_eventSky();
dllfunction fsaa_eventEntities();
dllfunction fsaa_reventLost();
dllfunction fsaa_setQuality(var);
function menu_over();

render_sky=fsaa_eventSky;
render_entities=fsaa_eventEntities;
on_d3d_lost=fsaa_reventLost;


include <materials.wdl>;
include <menus.wdl>;
include <story.wdl>;
include <games.wdl>;
include <cameras.wdl>;
include <particles.wdl>;
include <snake_movement.wdl>;
include <enemies.wdl>;
include <objects.wdl>;
/////////////////////////////////////////////////////////////////////////////////////////////
function main
{
	dll_open("fsaa.dll");
	opt_init();
	menus.pos_x = -800;
	menus.pos_y = -600;
	if(viewed_movie == 0)
	{
		story_start();
	}
	else
	{
		story_splash();
	}
}