//////////////////////////////////////////////////////////////////////////////////////////
entity* save_you;
function place_mouse();
//dumb mouse ai
//just look around 4 places and look for a box
//avoid walls and other stuff also included
//////////////////////////////////////////////////////////////////////////////////////////
function random_direction(direction_offset)
{
	my.direction = int(random(4));
	//random direction
	if(my.direction == up)
	{
		vec_set(temp.x,my.x);
		temp.y+=direction_offset;
		c_trace(my.x,temp.x,ignore_me);
		if(trace_hit == 0)
		{
			vec_set(my.targetpos_x,temp.x);
		}
	}
	if(my.direction == right)
	{
		vec_set(temp.x,my.x);
		temp.x+=direction_offset;
		c_trace(my.x,temp.x,ignore_me);
		if(trace_hit == 0)
		{
			vec_set(my.targetpos_x,temp.x);
		}
	}
	if(my.direction == down)
	{
		vec_set(temp.x,my.x);
		temp.y-=direction_offset;
		c_trace(my.x,temp.x,ignore_me);
		if(trace_hit == 0)
		{
			vec_set(my.targetpos_x,temp.x);
		}
	}
	if(my.direction == left)
	{
		vec_set(temp.x,my.x);
		temp.x-=direction_offset;
		c_trace(my.x,temp.x,ignore_me);
		if(trace_hit == 0)
		{
			vec_set(my.targetpos_x,temp.x);
		}
	}
	target_grid();
}
//////////////////////////////////////////////////////////////////////////////////////////
function check_obstacle
{
	c_trace(my.x,my.targetpos_x,ignore_me + use_box);
	if(trace_hit == 1)
	{
		random_direction(64);
	}
	target_grid();
}
//////////////////////////////////////////////////////////////////////////////////////////
function check_attack
{
	you = ptr_for_handle(my.target_entity);
	if(!you){return;}
	if(my.aggression < 100){return;}
	if(vec_dist(my.x,your.x) < 90 && your.ent_type == type_box)
	{
		files_lost+=1;
		random_direction(192);
		boxes_destroyed+=1;
		effect(part_box_destroy,100,your.x,nullvector);
		ent_remove(you);
		my.aggression -= 100;
		my.target_entity = 0;
		you = null;
	}
}
//////////////////////////////////////////////////////////////////////////////////////////
function mouse_target
{
	my.aggression+=time_Step;
	if(my.ent_type == type_mouse)
	{
		check_attack();
	}
	if(my.ent_type == type_hacker)
	{
		my.aggression+=time_Step;
		result = int(random(4));
		if(result == 0 || result == 1)
		{
			check_attack();
		}
		if(result == 2)
		{
			place_mouse();
		}	
		if(result == 3)
		{
			throw_bomb();
		}
	}
	if(vec_dist(my.x,my.targetpos_x) > 20)
	{
		//having a target
		return;
	}
	//searching for interesting places
	my.direction = int(random(4));
	if(my.direction == up)
	{
		vec_set(temp.x,my.x);
		temp.y+=256;
	}
	if(my.direction == right)
	{
		vec_set(temp.x,my.x);
		temp.x+=256;
	}
	if(my.direction == down)
	{
		vec_set(temp.x,my.x);
		temp.y-=256;
	}
	if(my.direction == left)
	{
		vec_set(temp.x,my.x);
		temp.x-=256;
	}
	if(my.aggression > 100)
	{
		c_trace(my.x,temp.x,ignore_me+ignore_passents);
		if(you)
		{
			//found something
			//move to it
			if(your.ent_type == type_box)
			{
				vec_set(my.targetpos_x,your.x);
				my.target_entity = handle(you);
				target_grid();
				return;
			}
		}
	}
	random_direction(64);
}
//////////////////////////////////////////////////////////////////////////////////////////
//to face the right angle
function mouse_turn
{
	if(my.direction == up){my.pan = 90;}
	if(my.direction == right){my.pan = 0;}
	if(my.direction == down){my.pan = 270;}
	if(my.direction == left){my.pan = 180;}
}
//////////////////////////////////////////////////////////////////////////////////////////
action put_on_floor
{
	vec_set(temp.x,my.x);
	temp.z-=256;
	c_trace(my.x,temp.x,ignore_me);
}
//the mouse action itself
action mouse
{
	position_grid();
	my.aggression = random(100);
	my.ent_type = type_mouse;
	wait(1);
	c_setminmax(me);
	put_on_floor();
	my.health = 1;
	my.speed = 5;
	vec_set(my.targetpos_x,my.x);
	position_grid();
	while(my.health > 0)
	{
		while(game_active == 0){wait(1);}
		check_obstacle();
		mouse_target();
		snake_movement_classic();
		mouse_turn();
		wait(1);
	}
	snd_play(menu_click_snd,70,0);
	effect(part_mouse_destroy,100,my.x,nullvector);
	add_block();
	wait(1);
	mice_eaten+=1;
	ent_remove(me);
}
//////////////////////////////////////////////////////////////////////////////////////////
//the hacker:
//features:
//-spawning mice
//-spawning bombs
//-destroying files
//////////////////////////////////////////////////////////////////////////////////////////
//placing mice, a hacker's function
function mouse_new
{
	position_grid();
	my.passable = on;
	my.transparent = on;
	my.alpha = 0;
	mice_level +=1;
	while(my.alpha < 80)
	{
		my.alpha+=time_step*2;
		wait(1);
	}
	if(!player){Return;}
	if(vec_dist(player.x,my.x) < 1000)
	{
		snd_play(mouse_birth_snd,50,0);
	}
	my.alpha = 100;
	my.transparent = off;
	my.passable = off;
	mouse();
}
function place_mouse
{
	if(my.aggression < 100){return;}
	if(mice_level > 20){return;}
	my.speed = 0;
	my.aggression -= 400;
	ent_create("mouse.mdl",my.x,mouse_new);
	wait(2);
	my.speed = 10;
}
//////////////////////////////////////////////////////////////////////////////////////////
//throwing bombs: another function,
//the hacker creates a bomb and sends it into a random direction
function bomb_target
{
	if(my.direction == up)
	{
		vec_set(my.targetpos_x,my.x);
		my.targetpos_y+=256;
	}
	if(my.direction == right)
	{
		vec_set(my.targetpos_x,my.x);
		my.targetpos_x+=256;
	}
	if(my.direction == down)
	{
		vec_set(my.targetpos_x,my.x);
		my.targetpos_y-=256;
	}
	if(my.direction == left)
	{
		vec_set(my.targetpos_x,my.x);
		my.targetpos_x-=256;
	}
}
function bomb_act
{
	position_grid();
	my.passable = on;
	my.transparent = on;
	my.alpha = 0;
	while(my.alpha < 80)
	{
		my.alpha+=time_step*2;
		wait(1);
	}
	if(!player){Return;}
	if(vec_dist(player.x,my.x) < 1000)
	{
		snd_play(mouse_birth_snd,50,0);
	}
	my.alpha = 100;
	my.transparent = off;
	my.passable = off;
	
	my.ent_type = type_bomb;
	my.direction = int(random(4));
	my.speed = 5;
	bomb_target();
	target_grid();
	wait(-0.2);
	my.health = 100;
	while(my.health > 0)
	{
		my.health-=time_step;
		bomb_target();
		my.move_x = sign(my.targetpos_x-my.x)*my.speed*time_step;
		my.move_y = sign(my.targetpos_y-my.y)*my.speed*time_step;
		my.move_z = sign(my.targetpos_z-my.z)*my.speed*time_step;
		vec_set(temp,my.x);
		vec_add(temp,my.move_x);
		c_trace(my.x,temp,ignore_me + ignore_passents + use_box);
		if(trace_hit == 0)
		{
			vec_add(my.x,my.move_x);
			//moving left or right
			if(abs(my.targetpos_x-my.x) > abs(my.targetpos_y-my.y))
			{
				my.y = my.targetpos_y;
			}
			//moving up or down
			if(abs(my.targetpos_x-my.x) < abs(my.targetpos_y-my.y))
			{
				my.x = my.targetpos_x;
			}
		}
		if(trace_hit == 1 && you)
		{
			if(your.ent_type == type_snake)
			{
				break;
			}
			if(your.ent_type == type_mouse)
			{
				my.direction = int(random(4));
				bomb_target();
			}
			if(your.ent_type == type_box)
			{
				files_lost+=1;
				boxes_destroyed+=1;
				effect(part_box_destroy,100,your.x,nullvector);
				ent_remove(you);
				break;
			}
			if(your.ent_type == type_hacker)
			{
				my.direction = int(random(4));
				bomb_target();
			}
			if(your.ent_type == type_bomb)
			{
				your.health = 0;
				break;
			}
			break;
		}
		wait(1);
	}
	snd_play(menu_click_snd,70,0);
	effect(part_bomb1,100,my.x,nullvector);
	effect(part_bomb2,100,my.x,nullvector);
	ent_remove(me);
}
function throw_bomb
{
	if(my.aggression < 100){return;}
	my.aggression -= 100;
	ent_create("bomb.mdl",my.x,bomb_act);
}
//////////////////////////////////////////////////////////////////////////////////////////
//the hacker himself
action hacker
{
	my.aggression = random(100);
	my.ent_type = type_hacker;
	wait(1);
	c_setminmax(me);
	put_on_floor();
	my.health = 1;
	my.speed = 10;
	vec_set(my.targetpos_x,my.x);
	position_grid();
	while(my.health > 0)
	{
		while(game_active == 0){wait(1);}
		check_obstacle();
		mouse_target();
		snake_movement_classic();
		mouse_turn();
		wait(1);
	}
	snd_play(menu_click_snd,70,0);
	effect(part_hacker_destroy1,100,my.x,nullvector);
	effect(part_hacker_destroy2,100,my.x,nullvector);
	add_block();
	wait(1);
	hackers_eaten+=1;
	ent_remove(me);
}